#ifndef __GPIO_H
#define __GPIO_H
#include "CH57x_common.h"

/* PA0~PA23 */
#define GPIOA_Pin_0                 (0x00000001)  /*!< Pin 0 selected */
#define GPIOA_Pin_1                 (0x00000002)  /*!< Pin 1 selected */
#define GPIOA_Pin_2                 (0x00000004)  /*!< Pin 2 selected */
#define GPIOA_Pin_3                 (0x00000008)  /*!< Pin 3 selected */
#define GPIOA_Pin_4                 (0x00000010)  /*!< Pin 4 selected */
#define GPIOA_Pin_5                 (0x00000020)  /*!< Pin 5 selected */
#define GPIOA_Pin_6                 (0x00000040)  /*!< Pin 6 selected */
#define GPIOA_Pin_7                 (0x00000080)  /*!< Pin 7 selected */
#define GPIOA_Pin_8                 (0x00000100)  /*!< Pin 8 selected */
#define GPIOA_Pin_9                 (0x00000200)  /*!< Pin 9 selected */
#define GPIOA_Pin_10                (0x00000400)  /*!< Pin 10 selected */
#define GPIOA_Pin_11                (0x00000800)  /*!< Pin 11 selected */
#define GPIOA_Pin_12                (0x00001000)  /*!< Pin 12 selected */
#define GPIOA_Pin_13                (0x00002000)  /*!< Pin 13 selected */
#define GPIOA_Pin_14                (0x00004000)  /*!< Pin 14 selected */
#define GPIOA_Pin_15                (0x00008000)  /*!< Pin 15 selected */
#define GPIOA_Pin_16                (0x00010000)  /*!< Pin 16 selected */
#define GPIOA_Pin_17                (0x00020000)  /*!< Pin 17 selected */
#define GPIOA_Pin_18                (0x00040000)  /*!< Pin 18 selected */
#define GPIOA_Pin_19                (0x00080000)  /*!< Pin 19 selected */
#define GPIOA_Pin_20                (0x00100000)  /*!< Pin 20 selected */
#define GPIOA_Pin_21                (0x00200000)  /*!< Pin 21 selected */
#define GPIOA_Pin_22                (0x00400000)  /*!< Pin 22 selected */
#define GPIOA_Pin_23                (0x00800000)  /*!< Pin 23 selected */

/* PB0~PB23 */
#define GPIOB_Pin_0                 (0x80000001)  /*!< Pin 0 selected */
#define GPIOB_Pin_1                 (0x80000002)  /*!< Pin 1 selected */
#define GPIOB_Pin_2                 (0x80000004)  /*!< Pin 2 selected */
#define GPIOB_Pin_3                 (0x80000008)  /*!< Pin 3 selected */
#define GPIOB_Pin_4                 (0x80000010)  /*!< Pin 4 selected */
#define GPIOB_Pin_5                 (0x80000020)  /*!< Pin 5 selected */
#define GPIOB_Pin_6                 (0x80000040)  /*!< Pin 6 selected */
#define GPIOB_Pin_7                 (0x80000080)  /*!< Pin 7 selected */
#define GPIOB_Pin_8                 (0x80000100)  /*!< Pin 8 selected */
#define GPIOB_Pin_9                 (0x80000200)  /*!< Pin 9 selected */
#define GPIOB_Pin_10                (0x80000400)  /*!< Pin 10 selected */
#define GPIOB_Pin_11                (0x80000800)  /*!< Pin 11 selected */
#define GPIOB_Pin_12                (0x80001000)  /*!< Pin 12 selected */
#define GPIOB_Pin_13                (0x80002000)  /*!< Pin 13 selected */
#define GPIOB_Pin_14                (0x80004000)  /*!< Pin 14 selected */
#define GPIOB_Pin_15                (0x80008000)  /*!< Pin 15 selected */
#define GPIOB_Pin_16                (0x80010000)  /*!< Pin 16 selected */
#define GPIOB_Pin_17                (0x80020000)  /*!< Pin 17 selected */
#define GPIOB_Pin_18                (0x80040000)  /*!< Pin 18 selected */
#define GPIOB_Pin_19                (0x80080000)  /*!< Pin 19 selected */
#define GPIOB_Pin_20                (0x80100000)  /*!< Pin 20 selected */
#define GPIOB_Pin_21                (0x80200000)  /*!< Pin 21 selected */
#define GPIOB_Pin_22                (0x80400000)  /*!< Pin 22 selected */
#define GPIOB_Pin_23                (0x80800000)  /*!< Pin 23 selected */

void GPIO_ModeCfg(UINT32 pin, GPIOModeTypeDef mode);
void GPIO_SetBits(UINT32 pin);
void GPIO_ResetBits(UINT32 pin);

#endif
