/*********************************************************
ע⣺Բͬĵ·ݡ衢еĲֵҪУ׼
*********************************************************/

#include "partcheck.h"

MEASUREPORT HighPort 					= {GPIOA_Pin_13, GPIOA_Pin_12, GPIOA_Pin_4};				//1PA13(޵),PA12(680),PA4(470K)
MEASUREPORT TristatePort 			= {GPIOA_Pin_14, GPIOB_Pin_13, GPIOB_Pin_12};				//2PA14(޵),PB13(680),PB12(470K)
MEASUREPORT LowPort 					= {GPIOA_Pin_15, GPIOB_Pin_15, GPIOB_Pin_14};				//3PA15(޵),PB15(680),PB14(470K)
COMPONENTTYPE ComponentFound 	= COMPONENT_NONE;					//
COMPONENTPARAMETER ComponentParam;											//


/*******************************************************************************
* Function Name  : Component_QuickCheck
* Description    : Ԫжͣͨͨ·֮ͨж
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : None
*******************************************************************************/
void Component_QuickCheck(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin)
{
	UINT16 adcget1;															//ɼADC
	double realvol1;														//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;									//ADCģʽ
	UINT8 temp = 0;
	QUICKJUDGE result = {0};
	UINT8 BJTFEA[3] 	= {0,1,1};								//BJT
	UINT8 JFETFEA[3] 	= {1,1,2};								//JFET
	UINT8 EMOSFEA[3] 	= {0,0,1};								//EMOSͶܵ
	UINT8 DMOSFEA[3] 	= {0,0,2};								//DMOS衢С(δȫŸɾ)
	UINT8 CAPFEA[3] 	= {0,0,0};								//ݵ
	
	Component_Discharge();																					//ŵ
	MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);		//TristatePort->HighPort
	MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);				
	MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
	DelayMs(50);
	mode = ADC_AutoPGASelect(HighPin);
	adcget1 = ADC_GetAverage(mode, HighPin, 1);
	realvol1 = ADC_RealVol(mode, adcget1);
//	PRINT("%f\n", realvol1);
	if(realvol1>0.036)
		result.Bth = 1;
	
	Component_Discharge();																					//ŵ
	MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);				//HighPort->TristatePort
	MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
	DelayMs(50);
	mode = ADC_AutoPGASelect(TristatePin);
	adcget1 = ADC_GetAverage(mode, TristatePin, 1);
	realvol1 = ADC_RealVol(mode, adcget1);
//	PRINT("%f\n", realvol1);
	if(realvol1>0.036)
		result.Bht = 1;
	
	Component_Discharge();																					//ŵ
	MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);		//TristatePort->LowPin
	MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);				
	DelayMs(50);
	mode = ADC_AutoPGASelect(LowPin);
	adcget1 = ADC_GetAverage(mode, LowPin, 1);
	realvol1 = ADC_RealVol(mode, adcget1);
//	PRINT("result.Btl = %f\n", realvol1);
	if(realvol1>0.036)
		result.Btl = 1;
	
	Component_Discharge();																					//ŵ
	MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);					//LowPin->TristatePort
	MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);				
	DelayMs(50);
	mode = ADC_AutoPGASelect(TristatePin);
	adcget1 = ADC_GetAverage(mode, TristatePin, 1);
	realvol1 = ADC_RealVol(mode, adcget1);
//	PRINT("result.Blt = %f\n", realvol1);
	if(realvol1>0.036)
		result.Blt = 1;
	
	Component_Discharge();																					//ŵ
	MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);				//HighPort->LowPort
	MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
	DelayMs(50);
	mode = ADC_AutoPGASelect(LowPin);
	adcget1 = ADC_GetAverage(mode, LowPin, 1);
	realvol1 = ADC_RealVol(mode, adcget1);
//	PRINT("%f\n", realvol1);
	if(realvol1>0.036)
		result.Bhl = 1;
	
	Component_Discharge();																					//ŵ
	MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);					//LowPort->HighPort
	MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
	DelayMs(50);
	mode = ADC_AutoPGASelect(HighPin);
	adcget1 = ADC_GetAverage(mode, HighPin, 1);
	realvol1 = ADC_RealVol(mode, adcget1);
//	PRINT("%f\n", realvol1);
	if(realvol1>0.036)
		result.Blh = 1;
	
	result.Sta[0] = result.Bth + result.Bht;
	result.Sta[1] = result.Btl + result.Blt;
	result.Sta[2] = result.Bhl + result.Blh;	
	
//	PRINT("%d%d%d\n",result.Sta[0], result.Sta[1], result.Sta[2]);
	
	if(StringCompare(result.Sta, CAPFEA, 3))																							//͵ݵֵԱ
	{
		if(ComponentIsCAP_Check(HighPin, TristatePin, LowPin))															//жǵݻûн
		{	
			ComponentFound = COMPONENT_CAPACITANCE;
			Capacitance_Check(ComponentParam.CAPPARAM.front, ComponentParam.CAPPARAM.rear);		//ݲ
		}
		else if(ComponentIsRES_Check(HighPin, TristatePin, LowPin))													//жǷǵ裬ֵҲּⲻѹ
		{
			ComponentFound = COMPONENT_RESISTANCE;
			Resistance_Check(ComponentParam.RESPARAM.front, ComponentParam.RESPARAM.rear);		//
		}
	}
	else if(StringCompare(result.Sta, BJTFEA, 3))																					//BJTֵԱ
	{
		ComponentFound = COMPONENT_BJT;
		if(result.Sta[0] == 0)
		{
			ComponentParam.BJTPARAM.b = LowPin;																								//LowPinΪ
			if(result.Blt == 1)
			{
				ComponentParam.BJTPARAM.Channel = P_CHANNEL;																		//P
			}
			else
			{
				ComponentParam.BJTPARAM.Channel = N_CHANNEL;																		//N
			}
		}
		else if(result.Sta[1] == 0)
		{
			ComponentParam.BJTPARAM.b = HighPin;																							//HighPinΪ
			if(result.Bhl == 1)
			{
				ComponentParam.BJTPARAM.Channel = P_CHANNEL;																		//P
			}
			else
			{
				ComponentParam.BJTPARAM.Channel = N_CHANNEL;																		//N
			}
		}
		else
		{
			ComponentParam.BJTPARAM.b = TristatePin;																					//TristatePinΪ
			if(result.Bth == 1)
			{
				ComponentParam.BJTPARAM.Channel = P_CHANNEL;																		//P
			}
			else
			{
				ComponentParam.BJTPARAM.Channel = N_CHANNEL;																		//N
			}
		}
		BJT_Check(HighPin, TristatePin, LowPin);																						//BJT
	}
	
	else if(StringCompare(result.Sta, JFETFEA, 3))																				//JFETֵԱ
	{
		ComponentFound = COMPONENT_JFET;
		if(result.Sta[0] == 2)
		{
			ComponentParam.JFETPARAM.g = LowPin;																							//LowPinΪդ									
			if(result.Blt == 1)
			{
				ComponentParam.JFETPARAM.Channel = N_CHANNEL;																		//N
			}
			else
			{
				ComponentParam.JFETPARAM.Channel = P_CHANNEL;																		//P
			}
		}
		else if(result.Sta[1] == 2)
		{
			ComponentParam.JFETPARAM.g = HighPin;																							//HighPinΪդ													
			if(result.Bhl == 1)
			{
				ComponentParam.JFETPARAM.Channel = N_CHANNEL;																		//N
			}
			else
			{
				ComponentParam.JFETPARAM.Channel = P_CHANNEL;																		//P
			}
		}
		else
		{
			ComponentParam.JFETPARAM.g = TristatePin;																					//TristatePinΪդ
			if(result.Bth == 1)
			{
				ComponentParam.JFETPARAM.Channel = N_CHANNEL;																		//N
			}
			else
			{
				ComponentParam.JFETPARAM.Channel = P_CHANNEL;																		//P
			}
		}
		JFET_Check(HighPin, TristatePin, LowPin);																						//JFET
	}
	
	else if(StringCompare(result.Sta, EMOSFEA, 3))																				//EMOSֵԱ
	{
		if(ComponentIsEMOS_Check(HighPin, TristatePin, LowPin, &result))										//жǷΪEMOS
		{
			ComponentFound = COMPONENT_MOS;
			EMOS_Check(HighPin, TristatePin, LowPin);																					//EMOS
		}
		else																																								//жǷΪ
		{
			ComponentFound = COMPONENT_DIODE;
			if(result.Sta[0] == 1)
			{
				if(result.Bth == 1)
				{
					ComponentParam.DiodeParam.front = TristatePin;																//޼ԣĬԱСķǰ
					ComponentParam.DiodeParam.rear = HighPin;
				}
				else
				{
					ComponentParam.DiodeParam.front = HighPin;
					ComponentParam.DiodeParam.rear = TristatePin;
				}
			}
			else if(result.Sta[1] == 1)
			{
				if(result.Btl == 1)
				{
					ComponentParam.DiodeParam.front = TristatePin;
					ComponentParam.DiodeParam.rear = LowPin;
				}
				else
				{
					ComponentParam.DiodeParam.front = LowPin;
					ComponentParam.DiodeParam.rear = TristatePin;
				}
			}
			else
			{
				if(result.Bhl== 1)
				{
					ComponentParam.DiodeParam.front = HighPin;
					ComponentParam.DiodeParam.rear = LowPin;
				}
				else
				{
					ComponentParam.DiodeParam.front = LowPin;
					ComponentParam.DiodeParam.rear = HighPin;
				}
			}
			Diode_Check(ComponentParam.DiodeParam.front, ComponentParam.DiodeParam.rear);							//ܲ
		}
	}
	
	else if(StringCompare(result.Sta, DMOSFEA, 3))																								//DMOSֵԱ
	{
		temp = ComponentIsDMOS_Check(HighPin, TristatePin, LowPin, &result);												//жǷΪDMOSС
		
		if( temp == 1)
		{
			ComponentFound = COMPONENT_MOS;
			DMOS_Check(HighPin, TristatePin, LowPin);
		}
		else if(ComponentIsCAP_Check(HighPin, TristatePin, LowPin))																	//жǷΪݣݹøֵ
		{	
			ComponentFound = COMPONENT_CAPACITANCE;
			Capacitance_Check(ComponentParam.CAPPARAM.front, ComponentParam.CAPPARAM.rear);						//ݲ
		}	
		else if(temp == 2)																																					//Ϊ
		{
			ComponentFound = COMPONENT_INDUCTANCE;
			if(result.Sta[0] == 2)
			{
				ComponentParam.INDPARAM.front = HighPin;
				ComponentParam.INDPARAM.rear = TristatePin;
			}
			if(result.Sta[1] == 2)
			{
				ComponentParam.INDPARAM.front = TristatePin;
				ComponentParam.INDPARAM.rear = LowPin;
			}
			if(result.Sta[2] == 2)
			{
				ComponentParam.INDPARAM.front = HighPin;
				ComponentParam.INDPARAM.rear = LowPin;
			}
//			PRINT("%d%d\n",ComponentParam.INDPARAM.front,ComponentParam.INDPARAM.rear);
			Inductance_Check(ComponentParam.INDPARAM.front, ComponentParam.INDPARAM.rear);							//в
		}
		else																																													//Ϊ
		{
			ComponentFound = COMPONENT_RESISTANCE;
			if(result.Sta[0] == 2)
			{
				ComponentParam.RESPARAM.front = HighPin;
				ComponentParam.RESPARAM.rear = TristatePin;
			}
			if(result.Sta[1] == 2)
			{
				ComponentParam.RESPARAM.front = TristatePin;
				ComponentParam.RESPARAM.rear = LowPin;
			}
			if(result.Sta[2] == 2)
			{
				ComponentParam.RESPARAM.front = HighPin;
				ComponentParam.RESPARAM.rear = LowPin;
			}
			Resistance_Check(ComponentParam.RESPARAM.front, ComponentParam.RESPARAM.rear);								//
		}
	}
}


/*******************************************************************************
* Function Name  : ComponentIsCAP_Check
* Description    : жǷΪ
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : 0:1:
*******************************************************************************/
UINT8 ComponentIsCAP_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin)
{
	UINT16 adcget1, adcget2;								//ɼADC
	double realvol1, realvol2;							//ADCӦʵʵѹֵ
	
	Component_Discharge();																					//ŵ
	ADC_PGASet(ADC_PGA_0);
	//ݳ
	MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);					//TristatePort->HighPort
	MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);					
	MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);		
	adcget1 = ADC_GetAverage(ADC_PGA_0, HighPin, 1);								//ɼ¶˵ƽ
	realvol1 = ADC_RealVol(ADC_PGA_0, adcget1);
	MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);				//ӿٶ
	DelayMs(50);
	//ݷŵ
	MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);
	adcget2 = ADC_GetAverage(ADC_PGA_0, TristatePin, 1);						//ɼ϶˵ƽ
	realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
//	PRINT("%f\n%f\n", realvol1, realvol2);
	if((realvol1>0.036) && (realvol2>0.036))												//ʱ¶˲ɼƽŵʱ϶˲ɼĵƽ
	{
		ComponentParam.CAPPARAM.front = HighPin;
		ComponentParam.CAPPARAM.rear = TristatePin;
		return 1;
	}

	Component_Discharge();																					//ŵ
	ADC_PGASet(ADC_PGA_0);
	//ݳ
	MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);					//TristatePort->LowPort
	MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);		
	adcget1 = ADC_GetAverage(ADC_PGA_0, LowPin, 1);									//ɼ¶˵ƽ
	realvol1 = ADC_RealVol(ADC_PGA_0, adcget1);
	MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);					//ӿٶ
	DelayMs(50);
	//ݷŵ
	MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);
	adcget2 = ADC_GetAverage(ADC_PGA_0, TristatePin, 1);						//ɼ϶˵ƽ
	realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
//	PRINT("%f\n%f\n", realvol1, realvol2);
	if((realvol1>0.036) && (realvol2>0.036))												//ճʱ¶˲ɼƽŵʱ϶˲ɼĵƽ
	{
		ComponentParam.CAPPARAM.front = TristatePin;
		ComponentParam.CAPPARAM.rear = LowPin;
		return 1;
	}
	
	Component_Discharge();																					//ŵ
	ADC_PGASet(ADC_PGA_0);
	//ݳ
	MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);			//HighPort->LowPort
	MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
	adcget1 = ADC_GetAverage(ADC_PGA_0, LowPin, 1);									//ɼ¶˵ƽ
	realvol1 = ADC_RealVol(ADC_PGA_0, adcget1);
	MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);					//ӿٶ
	DelayMs(50);
	//ݷŵ
	MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);
	adcget2 = ADC_GetAverage(ADC_PGA_0, HighPin, 1);								//ɼ϶˵ƽ
	realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
//	PRINT("%f\n%f\n", realvol1, realvol2);
	if((realvol1>0.036) && (realvol2>0.036))												//ճʱ¶˲ɼƽŵʱ϶˲ɼĵƽ
	{
		ComponentParam.CAPPARAM.front = HighPin;
		ComponentParam.CAPPARAM.rear = LowPin;
		return 1;
	}
	
	return 0;
}


/*******************************************************************************
* Function Name  : Capacitance_Check
* Description    : ݼ
* Input          : FrontPin: Զ˿
									 RearPin: Զ˿
* Return         : None
*******************************************************************************/
void Capacitance_Check(UINT8 FrontPin, UINT8 RearPin)
{
	UINT16 adcget1, adcget2;						//ɼADC
	double realvol1, realvol2;					//ADCӦʵʵѹֵ
	UINT8 CAP_FLAG = 0;									//FLAG,жʹõĸ
	UINT32 count;												//ʱֵ
	double time;												//ʱʱ
	UINT16 i = 0;
	
	if((FrontPin==3) && (RearPin==5))																//ֽӷжϲ
	{
		Component_Discharge();
		//ݳ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);				//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);				//VCC---680-|-x---VCC
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);																			//ʹADC_PGA_1_4ģʽ
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
		//ݷŵ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);				//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);																				//ʹADC_PGA_0ģʽ
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)																										//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);		//ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---680-|-x---VCC
			MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
			//ݷŵ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);			//GND---680-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
			{
				ComponentFound 	= COMPONENT_NONE;
				return;
			}
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.CAPPARAM.CapVal = time/(470000*log(realvol1/realvol2));		//ֵ
		else
			ComponentParam.CAPPARAM.CapVal = time/(680*log(realvol1/realvol2));
	}
	
	else if((FrontPin==3) && (RearPin==4))
	{
		Component_Discharge();
		//ݳ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);						//ģʽĴڣͨŵֵ
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---680-|-x---VCC
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
		//ݷŵ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);						//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)																												//ŵٶ̫죬470Kѹ²
		{	
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);				//ģʽĴڣͨŵֵ
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);		//VCC---680-|-x---VCC
			MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
			//ݷŵ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);				//GND---680-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
			{
				ComponentFound 	= COMPONENT_NONE;
				return;
			}
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.CAPPARAM.CapVal = time/(470000*log(realvol1/realvol2));		//ֵ
		else
			ComponentParam.CAPPARAM.CapVal = time/(680*log(realvol1/realvol2));
	}
	
	else if((FrontPin==4) && (RearPin==5))
	{
		Component_Discharge();
		//ݳ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);		//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);				//VCC---680-|-x---VCC
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
		//ݷŵ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_POSITIVE);		//ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---680-|-x---VCC
			MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
			//ݷŵ
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);			//GND---680-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
			{
				ComponentFound 	= COMPONENT_NONE;
				return;
			}
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.CAPPARAM.CapVal = time/(470000*log(realvol1/realvol2));		//ֵ
		else
			ComponentParam.CAPPARAM.CapVal = time/(680*log(realvol1/realvol2));
	}
}


/*******************************************************************************
* Function Name  : BJT_Check
* Description    : ˫;ܼ
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : None
*******************************************************************************/
void BJT_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin)
{
	UINT16 adcget1, adcget2, adcget3, adcget4;						//ɼADC
	double realvol1, realvol2, realvol3, realvol4;				//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;														//ADCģʽ
	UINT16 hFE1, hFE2;
	
	if(ComponentParam.BJTPARAM.Channel == P_CHANNEL)							//NPNͣù缫·
	{
		if(ComponentParam.BJTPARAM.b == LowPin)											//LowPinǻ
		{
			//ComponentParam.BJTPARAM.c == TristatePin								//TristatePinΪ缫
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				mode = ADC_AutoPGASelect(TristatePin);
				adcget2 = ADC_GetAverage(mode, TristatePin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE1 = (3.3-realvol2)/(3.3-realvol1);
			}
			else																														//ѹֵ̫С470K
			{
				MeasurePort_Init(LowPort, PORT_WITH_470K, LV_POSITIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);		
				mode = ADC_AutoPGASelect(TristatePin);
				adcget2 = ADC_GetAverage(mode, TristatePin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);			
				hFE1 = (470000*(3.3-realvol2))/(680*(3.3-realvol1));			
			}
			
			//ComponentParam.BJTPARAM.c == HighPin													//HighPinΪ缫
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget3 = ADC_GetAverage(mode, LowPin, 1);
			realvol3 = ADC_RealVol(mode, adcget3);
			if(realvol3>0.036)
			{
				mode = ADC_AutoPGASelect(HighPin);
				adcget4 = ADC_GetAverage(mode, HighPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (3.3-realvol4)/(3.3-realvol3);
			}
			else																														//ѹֵ̫С470K
			{
				MeasurePort_Init(LowPort, PORT_WITH_470K, LV_POSITIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget3 = ADC_GetAverage(mode, LowPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				mode = ADC_AutoPGASelect(HighPin);
				adcget4 = ADC_GetAverage(mode, HighPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);		
				hFE2 = (470000*(3.3-realvol4))/(680*(3.3-realvol3));			
			}	

			if(hFE1>hFE2)																								//ŴǸΪȷķ
			{
				ComponentParam.BJTPARAM.c = TristatePin;									//缫
				ComponentParam.BJTPARAM.e = HighPin;											//伫
				ComponentParam.BJTPARAM.hFE = hFE1;												//Ŵ
				ComponentParam.BJTPARAM.Ube = realvol2;										//ͷ֮ĵѹ
			}
			else
			{
				ComponentParam.BJTPARAM.c = HighPin;					
				ComponentParam.BJTPARAM.e = TristatePin;
				ComponentParam.BJTPARAM.hFE = hFE2;
				ComponentParam.BJTPARAM.Ube = realvol4;				
			}	
		}
		
		else if(ComponentParam.BJTPARAM.b == HighPin)									//HighPinΪ
		{
			//ComponentParam.BJTPARAM.c == LowPin												//LowPinΪ缫
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				mode = ADC_AutoPGASelect(LowPin);
				adcget2 = ADC_GetAverage(mode, LowPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE1 = (3.3-realvol2)/(3.3-realvol1);
			}
			else																														//ѹֵ̫С470K
			{
				MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);		
				mode = ADC_AutoPGASelect(LowPin);
				adcget2 = ADC_GetAverage(mode, LowPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE1 = (470000*(3.3-realvol2))/(680*(3.3-realvol1));				
			}

			//ComponentParam.BJTPARAM.c == TristatePin										//TristatePinΪ缫
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget3 = ADC_GetAverage(mode, HighPin, 1);
			realvol3 = ADC_RealVol(mode, adcget3);
			if(realvol3>0.036)
			{
				mode = ADC_AutoPGASelect(TristatePin);
				adcget4 = ADC_GetAverage(mode, TristatePin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (3.3-realvol4)/(3.3-realvol3);
			}
			else																															//ѹֵ̫С470K
			{
				MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget3 = ADC_GetAverage(mode, HighPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget4 = ADC_GetAverage(mode, TristatePin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (470000*(3.3-realvol4))/(680*(3.3-realvol3));			
			}				
						
			if(hFE1>hFE2)																										//ŴǸΪȷķ
			{
				ComponentParam.BJTPARAM.c = LowPin;														//缫
				ComponentParam.BJTPARAM.e = TristatePin;											//
				ComponentParam.BJTPARAM.hFE = hFE1;														//Ŵ
				ComponentParam.BJTPARAM.Ube = realvol2;												//ͷ伫֮ĵѹ
			}
			else
			{
				ComponentParam.BJTPARAM.c = TristatePin;
				ComponentParam.BJTPARAM.e = LowPin;
				ComponentParam.BJTPARAM.hFE = hFE2;
				ComponentParam.BJTPARAM.Ube = realvol4;				
			}	
		}
		
		else																																	//TristatePinΪ
		{
			//ComponentParam.BJTPARAM.c == HighPin															//HighPinΪ缫
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				mode = ADC_AutoPGASelect(HighPin);
				adcget2 = ADC_GetAverage(mode, HighPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE1 = (3.3-realvol2)/(3.3-realvol1);
			}
			else
			{
				MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_POSITIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				mode = ADC_AutoPGASelect(HighPin);
				adcget2 = ADC_GetAverage(mode, HighPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE2 = (470000*(3.3-realvol2))/(680*(3.3-realvol1));				
			}

			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget3 = ADC_GetAverage(mode, TristatePin, 1);
			realvol3 = ADC_RealVol(mode, adcget3);
			if(realvol3>0.036)
			{
				mode = ADC_AutoPGASelect(LowPin);
				adcget4 = ADC_GetAverage(mode, LowPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (3.3-realvol4)/(3.3-realvol3);
			}
			else																																//ѹֵ̫С470K
			{
				MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_POSITIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget3 = ADC_GetAverage(mode, TristatePin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				mode = ADC_AutoPGASelect(LowPin);
				adcget4 = ADC_GetAverage(mode, LowPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (470000*(3.3-realvol4))/(680*(3.3-realvol3));				
			}
			
			if(hFE1>hFE2)																													//ŴǸΪȷķ
			{
				ComponentParam.BJTPARAM.c = HighPin;																//缫
				ComponentParam.BJTPARAM.e = LowPin;																	//伫
				ComponentParam.BJTPARAM.hFE = hFE1;																	//Ŵ
				ComponentParam.BJTPARAM.Ube = realvol2;															//ͷ伫֮ѹ
			}
			else
			{
				ComponentParam.BJTPARAM.c = LowPin;
				ComponentParam.BJTPARAM.e = HighPin;
				ComponentParam.BJTPARAM.hFE = hFE2;
				ComponentParam.BJTPARAM.Ube = realvol4;				
			}				
		}
	}
	
	else if(ComponentParam.BJTPARAM.Channel == N_CHANNEL)								//NPNͣù伫·в
	{
		if(ComponentParam.BJTPARAM.b == LowPin)														//LowPinΪ
		{
			//ComponentParam.BJTPARAM.c == TristatePin											//缫TristatePin
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				mode = ADC_AutoPGASelect(HighPin);
				adcget2 = ADC_GetAverage(mode, HighPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE1 = (3.3-realvol2)/realvol1;
			}
			else																														//ѹֵ̫С470K
			{
				MeasurePort_Init(LowPort, PORT_WITH_470K, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);				
				mode = ADC_AutoPGASelect(HighPin);
				adcget2 = ADC_GetAverage(mode, HighPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);			
				hFE1 = (470000*(3.3-realvol2))/(680*realvol1)-1;		
			}
			
			//ComponentParam.BJTPARAM.c == HighPin													//缫ΪHighPin
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget3 = ADC_GetAverage(mode, LowPin, 1);
			realvol3 = ADC_RealVol(mode, adcget3);
			if(realvol3>0.036)
			{
				mode = ADC_AutoPGASelect(TristatePin);
				adcget4 = ADC_GetAverage(mode, TristatePin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (3.3-realvol4)/realvol3;
			}
			else																														//ѹֵ̫С470K
			{
				MeasurePort_Init(LowPort, PORT_WITH_470K, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget3 = ADC_GetAverage(mode, LowPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);				
				mode = ADC_AutoPGASelect(TristatePin);
				adcget4 = ADC_GetAverage(mode, TristatePin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);				
				hFE2 = (470000*(3.3-realvol4))/(680*realvol3)-1;		
			}	
			
			if(hFE1>hFE2)																										//ŴǸΪȷķ
			{
				ComponentParam.BJTPARAM.c = TristatePin;											//缫
				ComponentParam.BJTPARAM.e = HighPin;													//伫
				ComponentParam.BJTPARAM.hFE = hFE1;														//Ŵ
				ComponentParam.BJTPARAM.Ube = realvol2 - realvol1;						//伫֮ĵѹ
			}
			else
			{
				ComponentParam.BJTPARAM.c = HighPin;
				ComponentParam.BJTPARAM.e = TristatePin;
				ComponentParam.BJTPARAM.hFE = hFE2;
				ComponentParam.BJTPARAM.Ube = realvol4 - realvol3;				
			}	
		}
		
		else if(ComponentParam.BJTPARAM.b == HighPin)											//HighPinΪ
		{
			//ComponentParam.BJTPARAM.c == LowPin														//缫ΪLowPin
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				mode = ADC_AutoPGASelect(TristatePin);
				adcget2 = ADC_GetAverage(mode, TristatePin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE1 = (3.3-realvol2)/realvol1;
			}						
			else																															//ѹֵ̫С470K
			{
				MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);				
				mode = ADC_AutoPGASelect(TristatePin);
				adcget2 = ADC_GetAverage(mode, TristatePin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);				
				hFE1 = (470000*(3.3-realvol2))/(680*realvol1)-1;		
			}

			//ComponentParam.BJTPARAM.c == TristatePin												//缫ΪTristatePin
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget3 = ADC_GetAverage(mode, HighPin, 1);
			realvol3 = ADC_RealVol(mode, adcget3);
			if(realvol3>0.036)
			{
				mode = ADC_AutoPGASelect(LowPin);
				adcget4 = ADC_GetAverage(mode, LowPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (3.3-realvol4)/realvol3;
			}
			else																														//ѹֵ̫С470K
			{
				MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget3 = ADC_GetAverage(mode, HighPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);			
				mode = ADC_AutoPGASelect(LowPin);
				adcget4 = ADC_GetAverage(mode, LowPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (470000*(3.3-realvol4))/(680*realvol3)-1;			
			}	

			if(hFE1>hFE2)																										//ŴǸΪȷķ
			{
				ComponentParam.BJTPARAM.c = LowPin;														//缫
				ComponentParam.BJTPARAM.e = TristatePin;											//伫
				ComponentParam.BJTPARAM.hFE = hFE1;														//Ŵ
				ComponentParam.BJTPARAM.Ube = realvol2 - realvol1;						//ͷ伫֮ĵѹ
			}
			else
			{
				ComponentParam.BJTPARAM.c = TristatePin;
				ComponentParam.BJTPARAM.e = LowPin;
				ComponentParam.BJTPARAM.hFE = hFE2;
				ComponentParam.BJTPARAM.Ube = realvol4 - realvol3;				
			}				
		}
		
		else																																//TristatePinΪ
		{
			//ComponentParam.BJTPARAM.c == HighPin														//輯缫ΪHighPin
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				mode = ADC_AutoPGASelect(LowPin);
				adcget2 = ADC_GetAverage(mode, LowPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);
				hFE1 = (3.3-realvol2)/realvol1;
			}
			else																															//ѹֵ̫С470K
			{
				MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);			
				mode = ADC_AutoPGASelect(LowPin);
				adcget2 = ADC_GetAverage(mode, LowPin, 1);
				realvol2 = ADC_RealVol(mode, adcget2);				
				hFE1 = (470000*(3.3-realvol2))/(680*realvol1)-1;		
			}

			//ComponentParam.BJTPARAM.c == LowPin															//輯缫ΪLowPin
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget3 = ADC_GetAverage(mode, TristatePin, 1);
			realvol3 = ADC_RealVol(mode, adcget3);
			if(realvol3>0.036)
			{
				mode = ADC_AutoPGASelect(HighPin);
				adcget4 = ADC_GetAverage(mode, HighPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);
				hFE2 = (3.3-realvol4)/realvol3;
			}
			else																															//ѹֵ̫С470K
			{
				MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget3 = ADC_GetAverage(mode, TristatePin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);				
				mode = ADC_AutoPGASelect(HighPin);
				adcget4 = ADC_GetAverage(mode, HighPin, 1);
				realvol4 = ADC_RealVol(mode, adcget4);				
				hFE2 = (470000*(3.3-realvol4))/(680*realvol3)-1;				
			}
				
			if(hFE1>hFE2)																										//ŴǸΪȷķ
			{
				ComponentParam.BJTPARAM.c = HighPin;													//缫
				ComponentParam.BJTPARAM.e = LowPin;														//伫
				ComponentParam.BJTPARAM.hFE = hFE1;														//Ŵ
				ComponentParam.BJTPARAM.Ube = realvol2 - realvol1;						//ͷ伫֮ĵѹ
			}
			else
			{
				ComponentParam.BJTPARAM.c = LowPin;
				ComponentParam.BJTPARAM.e = HighPin;
				ComponentParam.BJTPARAM.hFE = hFE2;
				ComponentParam.BJTPARAM.Ube = realvol4 - realvol3;				
			}
		}
	}
}
		

/*******************************************************************************
* Function Name  : JFET_Check
* Description    : JFET
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : None
*******************************************************************************/
void JFET_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin)
{
	UINT16 adcget1, adcget2, adcget3;						//ɼADC
	double realvol1, realvol2, realvol3;				//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;									//ADCģʽ
	
	if(ComponentParam.JFETPARAM.Channel == P_CHANNEL)									//P
	{
		if(ComponentParam.JFETPARAM.g == TristatePin)										//TristatePinΪդ
		{
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);				//HighPinΪ©ʱ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);			//LowPinΪ©ʱ
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget2 = ADC_GetAverage(mode, LowPin, 1);
			realvol2 = ADC_RealVol(mode, adcget2);
			
			if(realvol1<realvol2)																						//ѹֵǸΪȷķ
			{
				ComponentParam.JFETPARAM.d = LowPin;													//©
				ComponentParam.JFETPARAM.s = HighPin;													//Դ
				ComponentParam.JFETPARAM.Idss = realvol2/680;									//©
				
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget3 = ADC_GetAverage(mode, HighPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (3.3-adcget3)/(1-sqrt(((3.3-realvol3)/680)/ComponentParam.JFETPARAM.Idss));				//жϵѹ
			}
			else
			{
				ComponentParam.JFETPARAM.d = HighPin;
				ComponentParam.JFETPARAM.s = LowPin;
				ComponentParam.JFETPARAM.Idss = realvol1/680;
				
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget3 = ADC_GetAverage(mode, LowPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (3.3-adcget3)/(1-sqrt(((3.3-realvol3)/680)/ComponentParam.JFETPARAM.Idss));
			}
		}
		
		else if(ComponentParam.JFETPARAM.g == HighPin)										//HighPinΪդ
		{
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);					//LowPinΪ©ʱ
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);					//TristatePinΪ©ʱ
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget2 = ADC_GetAverage(mode, TristatePin, 1);
			realvol2 = ADC_RealVol(mode, adcget2);
			
			if(realvol1<realvol2)																						//ѹֵǸΪȷķ
			{
				ComponentParam.JFETPARAM.d = TristatePin;											//©
				ComponentParam.JFETPARAM.s = LowPin;													//Դ
				ComponentParam.JFETPARAM.Idss = realvol2/680;									//©
				
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget3 = ADC_GetAverage(mode, LowPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (3.3-adcget3)/(1-sqrt(((3.3-realvol3)/680)/ComponentParam.JFETPARAM.Idss));					//жϵѹ
			}
			else
			{
				ComponentParam.JFETPARAM.d = LowPin;
				ComponentParam.JFETPARAM.s = TristatePin;
				ComponentParam.JFETPARAM.Idss = realvol1/680;
				
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget3 = ADC_GetAverage(mode, TristatePin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (3.3-adcget3)/(1-sqrt(((3.3-realvol3)/680)/ComponentParam.JFETPARAM.Idss));
			}
		}
		
		else																																//LowPinΪդ
		{
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);				//TristatePinΪ©
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//HighPinΪ©
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget2 = ADC_GetAverage(mode, HighPin, 1);
			realvol2 = ADC_RealVol(mode, adcget2);
			
			if(realvol1<realvol2)																							//ѹֵǸΪȷķ
			{
				ComponentParam.JFETPARAM.d = HighPin;														//©
				ComponentParam.JFETPARAM.s = TristatePin;												//Դ
				ComponentParam.JFETPARAM.Idss = realvol2/680;										//©
				
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget3 = ADC_GetAverage(mode, TristatePin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (3.3-adcget3)/(1-sqrt(((3.3-realvol3)/680)/ComponentParam.JFETPARAM.Idss));			//жϵѹ
			}
			else
			{
				ComponentParam.JFETPARAM.d = TristatePin;
				ComponentParam.JFETPARAM.s = HighPin;
				ComponentParam.JFETPARAM.Idss = realvol1/680;
				
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget3 = ADC_GetAverage(mode, HighPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (3.3-adcget3)/(1-sqrt(((3.3-realvol3)/680)/ComponentParam.JFETPARAM.Idss));
			}
		}
	}
	else if(ComponentParam.JFETPARAM.Channel == N_CHANNEL)											//N
	{
		if(ComponentParam.JFETPARAM.g == TristatePin)															//TristatePinΪդ
		{
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);									//HighPinΪԴ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);

			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);								//LowPinΪԴ
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget2 = ADC_GetAverage(mode, LowPin, 1);
			realvol2 = ADC_RealVol(mode, adcget2);
			
			if(realvol1>realvol2)																										//ǸΪȷķ
			{
				ComponentParam.JFETPARAM.d = LowPin;																	//©
				ComponentParam.JFETPARAM.s = HighPin;																	//Դ
				ComponentParam.JFETPARAM.Idss = (3.3-realvol2)/680;										//©
				
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget3 = ADC_GetAverage(mode, HighPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (-adcget3)/(1-sqrt((realvol3/680)/ComponentParam.JFETPARAM.Idss));		//жϵѹ
			}
			else
			{
				ComponentParam.JFETPARAM.d = HighPin;
				ComponentParam.JFETPARAM.s = LowPin;
				ComponentParam.JFETPARAM.Idss = (3.3-realvol1)/680;
				
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget3 = ADC_GetAverage(mode, LowPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (-adcget3)/(1-sqrt((realvol3/680)/ComponentParam.JFETPARAM.Idss));
			}
		}
		
		else if(ComponentParam.JFETPARAM.g == HighPin)															//HighPinΪդ
		{
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);										//LowPinΪԴ
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);

			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);										//TristatePinΪԴ
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget2 = ADC_GetAverage(mode, TristatePin, 1);
			realvol2 = ADC_RealVol(mode, adcget2);
			
			if(realvol1>realvol2)																											//ǸΪȷķ
			{
				ComponentParam.JFETPARAM.d = TristatePin;																//©
				ComponentParam.JFETPARAM.s = LowPin;																		//Դ
				ComponentParam.JFETPARAM.Idss = (3.3-realvol2)/680;											//©
				
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget3 = ADC_GetAverage(mode, LowPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (-adcget3)/(1-sqrt((realvol3/680)/ComponentParam.JFETPARAM.Idss));			//жϵѹ
			}
			else
			{
				ComponentParam.JFETPARAM.d = LowPin;
				ComponentParam.JFETPARAM.s = TristatePin;
				ComponentParam.JFETPARAM.Idss = (3.3-realvol1)/680;
				
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget3 = ADC_GetAverage(mode, TristatePin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (-adcget3)/(1-sqrt((realvol3/680)/ComponentParam.JFETPARAM.Idss));
			}
		}
		
		else																																			//LowPinΪդ
		{
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);							//TristatePinΪԴ
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);

			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);						//HighPinΪԴ
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget2 = ADC_GetAverage(mode, HighPin, 1);
			realvol2 = ADC_RealVol(mode, adcget2);
			
			if(realvol1>realvol2)
			{
				ComponentParam.JFETPARAM.d = HighPin;
				ComponentParam.JFETPARAM.s = TristatePin;
				ComponentParam.JFETPARAM.Idss = (3.3-realvol2)/680;
				
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget3 = ADC_GetAverage(mode, TristatePin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (-adcget3)/(1-sqrt((realvol3/680)/ComponentParam.JFETPARAM.Idss));
			}
			else
			{
				ComponentParam.JFETPARAM.d = TristatePin;
				ComponentParam.JFETPARAM.s = HighPin;
				ComponentParam.JFETPARAM.Idss = (3.3-realvol1)/680;
				
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget3 = ADC_GetAverage(mode, HighPin, 1);
				realvol3 = ADC_RealVol(mode, adcget3);
				ComponentParam.JFETPARAM.Uoff = (-adcget3)/(1-sqrt((realvol3/680)/ComponentParam.JFETPARAM.Idss));
			}
		}
	}
}


/*******************************************************************************
* Function Name  : ComponentIsEMOS_Check
* Description    : жǷΪEMOS
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : 0:1:
*******************************************************************************/
UINT8 ComponentIsEMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin, QUICKJUDGE* presult)
{
	UINT16 adcget1;												//ɼADC
	double realvol1;											//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;						//ADCģʽ
	
	if(presult->Sta[0] == 1)							//դΪLowPin
	{
		if(presult->Bth == 1)								//©ΪHighPin
		{
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)																			//N
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
				ComponentParam.MOSFETPARAM.g = LowPin;
				ComponentParam.MOSFETPARAM.d = HighPin;
				ComponentParam.MOSFETPARAM.s = TristatePin;
				return 1;
			}
			
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)																			//P
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
				ComponentParam.MOSFETPARAM.g = LowPin;
				ComponentParam.MOSFETPARAM.d = TristatePin;
				ComponentParam.MOSFETPARAM.s = HighPin;
				return 1;
			}		
		}
		else																							//©ΪTristatePin
		{
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
				ComponentParam.MOSFETPARAM.g = LowPin;
				ComponentParam.MOSFETPARAM.d = TristatePin;
				ComponentParam.MOSFETPARAM.s = HighPin;
				return 1;
			}
			
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
				ComponentParam.MOSFETPARAM.g = LowPin;
				ComponentParam.MOSFETPARAM.d = HighPin;
				ComponentParam.MOSFETPARAM.s = TristatePin;
				return 1;
			}				
		}
	}
	
	else if(presult->Sta[1] == 1)													//դΪHighPin
	{
		if(presult->Blt == 1)																//©ΪTristatePin
		{
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
				ComponentParam.MOSFETPARAM.g = HighPin;
				ComponentParam.MOSFETPARAM.d = TristatePin;
				ComponentParam.MOSFETPARAM.s = LowPin;
				return 1;
			}
			
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
				ComponentParam.MOSFETPARAM.g = HighPin;
				ComponentParam.MOSFETPARAM.d = LowPin;
				ComponentParam.MOSFETPARAM.s = TristatePin;
				return 1;
			}		
		}
		else																														//©ΪLowPin
		{
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
				ComponentParam.MOSFETPARAM.g = HighPin;
				ComponentParam.MOSFETPARAM.d = LowPin;
				ComponentParam.MOSFETPARAM.s = TristatePin;
				return 1;
			}
			
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
				ComponentParam.MOSFETPARAM.g = HighPin;
				ComponentParam.MOSFETPARAM.d = TristatePin;
				ComponentParam.MOSFETPARAM.s = LowPin;
				return 1;
			}				
		}
	}
	
	else																														//դΪTristatePin
	{
		if(presult->Bhl == 1)																					//©ΪLowPin
		{
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
				ComponentParam.MOSFETPARAM.g = TristatePin;
				ComponentParam.MOSFETPARAM.d = LowPin;
				ComponentParam.MOSFETPARAM.s = HighPin;
				return 1;
			}
			
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
				ComponentParam.MOSFETPARAM.g = TristatePin;
				ComponentParam.MOSFETPARAM.d = HighPin;
				ComponentParam.MOSFETPARAM.s = LowPin;
				return 1;
			}		
		}
		else																														//©ΪHighPin
		{
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
				ComponentParam.MOSFETPARAM.g = TristatePin;
				ComponentParam.MOSFETPARAM.d = HighPin;
				ComponentParam.MOSFETPARAM.s = LowPin;
				return 1;
			}
			
			Component_Discharge();
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);			
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			if(realvol1>0.036)
			{
				ComponentParam.MOSFETPARAM.MODEL = E_MODEL;
				ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
				ComponentParam.MOSFETPARAM.g = TristatePin;
				ComponentParam.MOSFETPARAM.d = LowPin;
				ComponentParam.MOSFETPARAM.s = HighPin;
				return 1;
			}				
		}
	}
	return 0;
}


/*******************************************************************************
* Function Name  : EMOS_Check
* Description    : EMOS
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : None
*******************************************************************************/
void EMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin)
{
	UINT16 adcget1;													//ɼADC
	double realvol1;												//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;							//ADCģʽ
	
	if(ComponentParam.MOSFETPARAM.Channel == N_CHANNEL)
	{
		if(ComponentParam.MOSFETPARAM.g == LowPin)
		{
			if(ComponentParam.MOSFETPARAM.d == TristatePin)
			{
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = 3.3-realvol1;
				
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);				//©Դͨ
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
			else
			{
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);				//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = 3.3-realvol1;
				
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//©Դͨ
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}		
		}
		else if(ComponentParam.MOSFETPARAM.g == HighPin)
		{
			if(ComponentParam.MOSFETPARAM.d == LowPin)
			{
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);				//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = 3.3-realvol1;
				
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//©Դͨ
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
			else
			{
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = 3.3-realvol1;
				
				Component_Discharge();
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);						//©Դͨ
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
		}
		else
		{
			if(ComponentParam.MOSFETPARAM.d == HighPin)
			{
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = 3.3-realvol1;
				
				Component_Discharge();
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);						//©Դͨ
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
			else
			{
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = 3.3-realvol1;
				
				Component_Discharge();
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);					//©Դͨ
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}			
		}
	}
	
	else if(ComponentParam.MOSFETPARAM.Channel == P_CHANNEL)
	{
		if(ComponentParam.MOSFETPARAM.g == LowPin)
		{
			if(ComponentParam.MOSFETPARAM.d == TristatePin)
			{
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);			//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = realvol1;
				
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//©Դͨ
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
			else
			{
				Component_Discharge();
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);				//Ŵ·
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = realvol1;
				
				Component_Discharge();
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);				//©Դͨ
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}		
		}
		else if(ComponentParam.MOSFETPARAM.g == HighPin)
		{
			if(ComponentParam.MOSFETPARAM.d == LowPin)
			{
				Component_Discharge();
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);				//Ŵ·
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = realvol1;
				
				Component_Discharge();
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);					//©Դͨ
				MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(TristatePin);
				adcget1 = ADC_GetAverage(mode, TristatePin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
			else
			{
				Component_Discharge();
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);					//Ŵ·
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = realvol1;
				
				Component_Discharge();
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//©Դͨ
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
		}
		else
		{
			if(ComponentParam.MOSFETPARAM.d == HighPin)
			{
				Component_Discharge();
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);					//Ŵ·
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = realvol1;
				
				Component_Discharge();
				MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);				//©Դͨ
				MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(LowPin);
				adcget1 = ADC_GetAverage(mode, LowPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}
			else
			{
				Component_Discharge();
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);					//Ŵ·
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
				MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Uon = realvol1;
				
				Component_Discharge();
				MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);				//©Դͨ
				MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
				MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
				mode = ADC_AutoPGASelect(HighPin);
				adcget1 = ADC_GetAverage(mode, HighPin, 1);
				realvol1 = ADC_RealVol(mode, adcget1);
				ComponentParam.MOSFETPARAM.Ud = 3.3-realvol1;
			}			
		}
	}
}


/*******************************************************************************
* Function Name  : Diode_Check
* Description    : ܼ
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : None
*******************************************************************************/
void Diode_Check(UINT8 FrontPin, UINT8 RearPin)
{
	UINT16 adcget1, adcget2;												//ɼADC
	double realvol1, realvol2;											//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;											//ADCģʽ
	UINT8 CAP_FLAG = 0;															//FLAG,жʹõĸ
	UINT32 count;																		//ʱֵ
	double time;																		//ʱʱ
	UINT16 i = 0;
	
	if((FrontPin==3) && (RearPin==5))
	{
		//㵼ͨѹ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget1 = ADC_GetAverage(mode, FrontPin, 5);								//VCC---680-|-x---680---GND
		realvol1 = ADC_RealVol(mode, adcget1);
		mode = ADC_AutoPGASelect(RearPin);
		adcget2 = ADC_GetAverage(mode, RearPin, 5);									//VCC---680---x-|-680---GND
		realvol2 = ADC_RealVol(mode, adcget2);
		ComponentParam.DiodeParam.Uon = realvol1-realvol2;
		
		//㷴
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);		//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);			//GND---x-|-680---VCC
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
		//ݷŵ
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);			//GND---x-|-680---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);		//ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_470K, LV_POSITIVE);			//GND---x-|-470K---VCC
			MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
			//ݷŵ
			MeasurePort_Init(LowPort, PORT_WITH_470K, LV_NEGATIVE);			//GND---x-|-470K---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
				ComponentParam.DiodeParam.Cj = 0;
				return;
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.DiodeParam.Cj = time/(470000*log(realvol1/realvol2));
		else
			ComponentParam.DiodeParam.Cj = time/(680*log(realvol1/realvol2));
	}
		
	else if((FrontPin==5) && (RearPin==3))
	{
		//㵼ͨѹ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);		
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget1 = ADC_GetAverage(mode, FrontPin, 5);								//GND---680-|-x---680---VCC
		realvol1 = ADC_RealVol(mode, adcget1);
		mode = ADC_AutoPGASelect(RearPin);
		adcget2 = ADC_GetAverage(mode, RearPin, 5);									//GND---680---x-|-680---VCC
		realvol2 = ADC_RealVol(mode, adcget2);
		ComponentParam.DiodeParam.Uon = realvol1-realvol2;
		
		//㷴
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);			//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---680-|-x---GND
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
		//ݷŵ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);			//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);			  //ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);					//VCC---470K-|-x---GND
			MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
			//ݷŵ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);				//GND---470K-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
				ComponentParam.DiodeParam.Cj = 0;
				return;
		}
	
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.DiodeParam.Cj = time/(470000*log(realvol1/realvol2));
		else
			ComponentParam.DiodeParam.Cj = time/(680*log(realvol1/realvol2));
	}
	
	else if((FrontPin==3) && (RearPin==4))
	{
		//㵼ͨѹ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget1 = ADC_GetAverage(mode, FrontPin, 5);					//VCC---680-|-x---680---GND
		realvol1 = ADC_RealVol(mode, adcget1);
		mode = ADC_AutoPGASelect(RearPin);
		adcget2 = ADC_GetAverage(mode, RearPin, 5);						//VCC---680---x-|-680---GND
		realvol2 = ADC_RealVol(mode, adcget2);
		ComponentParam.DiodeParam.Uon = realvol1-realvol2;
		
		//㷴
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);				//ģʽĴڣͨŵֵ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);			//GND---x-|-680---VCC
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
		//ݷŵ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			//GND---x-|-680---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);					//ģʽĴڣͨŵֵ
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_POSITIVE);			//GND---x-|-470K---VCC
			MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
			//ݷŵ
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);			//GND---x-|-470K---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
				ComponentParam.DiodeParam.Cj = 0;
				return;
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.DiodeParam.Cj = time/(470000*log(realvol1/realvol2));
		else
			ComponentParam.DiodeParam.Cj = time/(680*log(realvol1/realvol2));
	}
		
	else if((FrontPin==4) && (RearPin==3))
	{
		//㵼ͨѹ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);		
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget1 = ADC_GetAverage(mode, FrontPin, 5);					//GND---680-|-x---680---VCC
		realvol1 = ADC_RealVol(mode, adcget1);
		mode = ADC_AutoPGASelect(RearPin);
		adcget2 = ADC_GetAverage(mode, RearPin, 5);						//GND---680---x-|-680---VCC
		realvol2 = ADC_RealVol(mode, adcget2);
		ComponentParam.DiodeParam.Uon = realvol1-realvol2;
		
		//㷴
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);						//ģʽĴڣͨŵֵ
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---680-|-x---GND
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
		//ݷŵ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);			//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);			  		//ģʽĴڣͨŵֵ
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);				//VCC---470K-|-x---GND
			MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
			//ݷŵ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);						//GND---470K-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
				ComponentParam.DiodeParam.Cj = 0;
				return;
		}
	
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.DiodeParam.Cj = time/(470000*log(realvol1/realvol2));
		else
			ComponentParam.DiodeParam.Cj = time/(680*log(realvol1/realvol2));
	}
		
	else if((FrontPin==4) && (RearPin==5))
	{
		//㵼ͨѹ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget1 = ADC_GetAverage(mode, FrontPin, 5);					//VCC---680-|-x---680---GND
		realvol1 = ADC_RealVol(mode, adcget1);
		mode = ADC_AutoPGASelect(RearPin);
		adcget2 = ADC_GetAverage(mode, RearPin, 5);						//VCC---680---x-|-680---GND
		realvol2 = ADC_RealVol(mode, adcget2);
		ComponentParam.DiodeParam.Uon = realvol1-realvol2;
		
		//㷴
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);		//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);					//GND---x-|-680---VCC
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
		//ݷŵ
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);					//GND---x-|-680---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);		//ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_470K, LV_POSITIVE);					//GND---x-|-470K---VCC
			MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
			//ݷŵ
			MeasurePort_Init(LowPort, PORT_WITH_470K, LV_NEGATIVE);					//GND---x-|-470K---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
				ComponentParam.DiodeParam.Cj = 0;
				return;
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.DiodeParam.Cj = time/(470000*log(realvol1/realvol2));
		else
			ComponentParam.DiodeParam.Cj = time/(680*log(realvol1/realvol2));
	}
		
	else if((FrontPin==5) && (RearPin==4))
	{
		//㵼ͨѹ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);		
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget1 = ADC_GetAverage(mode, FrontPin, 5);					//GND---680-|-x---680---VCC
		realvol1 = ADC_RealVol(mode, adcget1);
		mode = ADC_AutoPGASelect(RearPin);
		adcget2 = ADC_GetAverage(mode, RearPin, 5);						//GND---680---x-|-680---VCC
		realvol2 = ADC_RealVol(mode, adcget2);
		ComponentParam.DiodeParam.Uon = realvol1-realvol2;
		
		//㷴
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);		//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);				//VCC---680-|-x---GND
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
		//ݷŵ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			CAP_FLAG = 1;
			i = 0;
			//ݳ
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_POSITIVE);			  //ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);							//VCC---470K-|-x---GND
			MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, RearPin, 1);
			//ݷŵ
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);				//GND---470K-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, RearPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
				ComponentParam.DiodeParam.Cj = 0;
				return;
		}
	
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(CAP_FLAG)
			ComponentParam.DiodeParam.Cj = time/(470000*log(realvol1/realvol2));
		else
			ComponentParam.DiodeParam.Cj = time/(680*log(realvol1/realvol2));
	}		
}


/*******************************************************************************
* Function Name  : ComponentIsDMOS_Check
* Description    : жǷΪDMOS
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : 1:DMOS,2:,3:
*******************************************************************************/
UINT8 ComponentIsDMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin, QUICKJUDGE* presult)
{
	UINT16 adcget1, adcget2;								//ɼADC
	double realvol1, realvol2;							//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;							//ADCģʽ
	
	if(presult->Sta[0] == 2)																					//դΪLowPin
	{
		Component_Discharge();
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);					//դûеѹʱ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
		DelayMs(100);
		mode = ADC_AutoPGASelect(HighPin);
		adcget1 = ADC_GetAverage(mode, HighPin, 1);
		realvol1 = ADC_RealVol(mode, adcget1);
		
		Component_Discharge();
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);					//դеѹʱ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
		DelayMs(100);
		mode = ADC_AutoPGASelect(HighPin);
		adcget2 = ADC_GetAverage(mode, HighPin, 1);
		realvol2 = ADC_RealVol(mode, adcget2);
		if((realvol1-realvol2)>0.036)
		{
			ComponentParam.MOSFETPARAM.MODEL = D_MODEL;
			ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
			ComponentParam.MOSFETPARAM.g = LowPin;
			ComponentParam.MOSFETPARAM.d = TristatePin;
			ComponentParam.MOSFETPARAM.s = HighPin;
			return 1;
		}	
		else if((realvol1-realvol2)<(-0.036))
		{
			ComponentParam.MOSFETPARAM.MODEL = D_MODEL;
			ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
			ComponentParam.MOSFETPARAM.g = LowPin;
			ComponentParam.MOSFETPARAM.d = TristatePin;
			ComponentParam.MOSFETPARAM.s = HighPin;
			return 1;																								//ΪDMOS
		}
		else if((realvol1>5.13) && (realvol2>5.13))
		{
			return 2;																								//Ϊ
		}
		else
		{
			return 3;																								//Ϊ
		}
	}
			
	else if(presult->Sta[1] == 2)																			//HighpinΪդ
	{
		Component_Discharge();
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);				//դûеѹʱ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
		DelayMs(100);
		mode = ADC_AutoPGASelect(TristatePin);
		adcget1 = ADC_GetAverage(mode, TristatePin, 1);
		realvol1 = ADC_RealVol(mode, adcget1);
		
		Component_Discharge();
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);				//դеѹʱ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);
		DelayMs(100);
		mode = ADC_AutoPGASelect(TristatePin);
		adcget2 = ADC_GetAverage(mode, TristatePin, 1);
		realvol2 = ADC_RealVol(mode, adcget2);
		if((realvol1-realvol2)>0.036)
		{
			ComponentParam.MOSFETPARAM.MODEL = D_MODEL;
			ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
			ComponentParam.MOSFETPARAM.g = HighPin;
			ComponentParam.MOSFETPARAM.d = LowPin;
			ComponentParam.MOSFETPARAM.s = TristatePin;
			return 1;
		}	
		else if((realvol1-realvol2)<(-0.036))
		{
			ComponentParam.MOSFETPARAM.MODEL = D_MODEL;
			ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
			ComponentParam.MOSFETPARAM.g = HighPin;
			ComponentParam.MOSFETPARAM.d = LowPin;
			ComponentParam.MOSFETPARAM.s = TristatePin;
			return 1;																										//ΪDMOS
		}
		else if((realvol1>5.13) && (realvol2>5.13))
		{
			return 2;																										//Ϊ
		}
		else
		{
			return 3;																										//Ϊ
		}
	}	
	
	else																														//TristatePinΪդ
	{
		Component_Discharge();
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);			//դûеѹ
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
		DelayMs(100);
		mode = ADC_AutoPGASelect(LowPin);
		adcget1 = ADC_GetAverage(mode, LowPin, 1);
		realvol1 = ADC_RealVol(mode, adcget1);
		
		Component_Discharge();
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);			//դеѹ
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
		DelayMs(100);
		mode = ADC_AutoPGASelect(LowPin);
		adcget2 = ADC_GetAverage(mode, LowPin, 1);
		realvol2 = ADC_RealVol(mode, adcget2);
		if((realvol1-realvol2)>0.036)
		{
			ComponentParam.MOSFETPARAM.MODEL = D_MODEL;
			ComponentParam.MOSFETPARAM.Channel = P_CHANNEL;
			ComponentParam.MOSFETPARAM.g = TristatePin;
			ComponentParam.MOSFETPARAM.d = HighPin;
			ComponentParam.MOSFETPARAM.s = LowPin;
			return 1;
		}	
		else if((realvol1-realvol2)<(-0.036))
		{
			ComponentParam.MOSFETPARAM.MODEL = D_MODEL;
			ComponentParam.MOSFETPARAM.Channel = N_CHANNEL;
			ComponentParam.MOSFETPARAM.g = TristatePin;
			ComponentParam.MOSFETPARAM.d = HighPin;
			ComponentParam.MOSFETPARAM.s = LowPin;
			return 1;																								//ΪDMOS
		}
		else if((realvol1>5.13) && (realvol2>5.13))
		{
			return 2;																								//Ϊ
		}
		else
		{
			return 3;																								//Ϊ
		}	
	}
}


/*******************************************************************************
* Function Name  : DMOS_Check
* Description    : DMOS
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : None
*******************************************************************************/
void DMOS_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin)
{
	UINT16 adcget1;																	//ɼADC
	double realvol1;																//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;											//ADCģʽ
	
	if(ComponentParam.MOSFETPARAM.Channel == N_CHANNEL)											//N
	{
		if(ComponentParam.MOSFETPARAM.g == LowPin)														//LowPinΪդ
		{
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);				//Ugs=0
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Idss = realvol1/680;											//©
			
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Uoff = (3.3-realvol1)/(1-sqrt((realvol1/680)/ComponentParam.MOSFETPARAM.Idss));		//жϵѹ
		}
		
		else if(ComponentParam.MOSFETPARAM.g == HighPin)									//HighPinΪդ
		{
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			//Ugs=0
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Idss = realvol1/680;									//©
			
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Uoff = (3.3-realvol1)/(1-sqrt((realvol1/680)/ComponentParam.MOSFETPARAM.Idss));			//жϵѹ
		}
		
		else																																//TristatePinΪդ
		{
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);			//Ugs=0	
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Idss = realvol1/680;									//©
			
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Uoff = (3.3-realvol1)/(1-sqrt((realvol1/680)/ComponentParam.MOSFETPARAM.Idss));			//жϵѹ
		}
	}
	
	if(ComponentParam.MOSFETPARAM.Channel == P_CHANNEL)									//P
	{
		if(ComponentParam.MOSFETPARAM.g == LowPin)												//LowPinΪդ
		{
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			//Ugs=0
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Idss = realvol1/680;									//©
			
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(TristatePin);
			adcget1 = ADC_GetAverage(mode, TristatePin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Uoff = 3.3/(1-sqrt((realvol1/680)/ComponentParam.MOSFETPARAM.Idss));										//жϵѹ
		}
		
		else if(ComponentParam.MOSFETPARAM.g == HighPin)										//HighPinΪդ
		{
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//Ugs=0
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Idss = realvol1/680;									//©
			
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			
			MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
			mode = ADC_AutoPGASelect(LowPin);
			adcget1 = ADC_GetAverage(mode, LowPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Uoff = 3.3/(1-sqrt((realvol1/680)/ComponentParam.MOSFETPARAM.Idss));											//жϵѹ
		}
		
		else																																//TristatePinΪդ
		{
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);			//Ugs=0
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Idss = realvol1/680;									//©
			
			Component_Discharge();
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);			
			MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
			mode = ADC_AutoPGASelect(HighPin);
			adcget1 = ADC_GetAverage(mode, HighPin, 1);
			realvol1 = ADC_RealVol(mode, adcget1);
			ComponentParam.MOSFETPARAM.Uoff = 3.3/(1-sqrt((realvol1/680)/ComponentParam.MOSFETPARAM.Idss));													//жϵѹ
		}
	}
}


/*******************************************************************************
* Function Name  : Inductance_Check
* Description    : м
* Input          : FrontPin: Զ˿
									 RearPin: Զ˿
* Return         : None
*******************************************************************************/
void Inductance_Check(UINT8 FrontPin, UINT8 RearPin)
{
	UINT16 adcget1, adcget2;						//ɼADC
	double realvol1, realvol2;					//ADCӦʵʵѹֵ
	UINT8 IND_FLAG = 0;									//FLAG,жʹõĸ
	UINT32 count;												//ʱֵ
	double time;												//ʱʱ
	UINT16 i = 0;
	
	if((FrontPin==3) && (RearPin==5))
	{
		//г
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);			//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---680-|-x---GND
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
		//зŵ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);			//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			IND_FLAG = 1;
			i = 0;
			//г
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);		//ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---470K-|-x---GND
			MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
			//зŵ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);		//GND---470K-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
			{
				ComponentFound 	= COMPONENT_NONE;
				return;
			}
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(IND_FLAG)
			ComponentParam.RESPARAM.ResVal = (time*470000)/log(realvol1/realvol2);
		else
			ComponentParam.RESPARAM.ResVal = (time*680)/log(realvol1/realvol2);
	}
	
	else if((FrontPin==3) && (RearPin==4))
	{
		//г
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_POSITIVE);						//ģʽĴڣͨŵֵ
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---680-|-x---GND
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
		//зŵ
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);						//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			IND_FLAG = 1;
			i = 0;
			//г
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_POSITIVE);					//ģʽĴڣͨŵֵ
			MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);			//VCC---470K-|-x---GND
			MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
			//зŵ
			MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);					//GND---470K-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
			{
				ComponentFound 	= COMPONENT_NONE;
				return;
			}
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(IND_FLAG)
			ComponentParam.RESPARAM.ResVal = (time*470000)/log(realvol1/realvol2);
		else
			ComponentParam.RESPARAM.ResVal = (time*680)/log(realvol1/realvol2);
	}
	
	else if((FrontPin==4) && (RearPin==5))
	{
		//г
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);							//ģʽĴڣͨŵֵ
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);									//VCC---680-|-x---GND
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		DelayMs(100);
		ADC_PGASet(ADC_PGA_1_4);
		adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
		//зŵ
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);							//GND---680-|-x---GND
		Timer1_Init(0x3FFFFFF);
		ADC_PGASet(ADC_PGA_0);
		while(i < 0xFFFF)
		{
			adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
			count = TMR1_GetCurrentCount();
			if(adcget2 < 65)
			{
				break;
			}
			++i;
		}
		if(i < 100)				//ŵٶ̫죬470Kѹ²
		{
			IND_FLAG = 1;
			i = 0;
			//г
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_POSITIVE);			//ģʽĴڣͨŵֵ
			MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);						//VCC---470K-|-x---GND
			MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
			DelayMs(100);
			ADC_PGASet(ADC_PGA_1_4);
			adcget1 = ADC_GetAverage(ADC_PGA_1_4, FrontPin, 1);
			//зŵ
			MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);			//GND---470K-|-x---GND
			Timer1_Init(0x3FFFFFF);
			ADC_PGASet(ADC_PGA_0);
			while(i < 0xFFFF)
			{
				adcget2 = ADC_GetAverage(ADC_PGA_0, FrontPin, 1); 
				count = TMR1_GetCurrentCount();
				if(adcget2 < 65)
				{
					break;
				}
				++i;
			}
			if(i == 0)
			{
				ComponentFound 	= COMPONENT_NONE;
				return;
			}
		}
		
		realvol1 = ADC_RealVol(ADC_PGA_1_4, adcget1);
		realvol2 = ADC_RealVol(ADC_PGA_0, adcget2);
		time = 32.25 * count;	
		if(IND_FLAG)
			ComponentParam.RESPARAM.ResVal = (time*470000)/log(realvol1/realvol2);
		else
			ComponentParam.RESPARAM.ResVal = (time*680)/log(realvol1/realvol2);
	}
}


/*******************************************************************************
* Function Name  : ComponentIsRES_Check
* Description    : жǷΪ
* Input          : HighPin: Զ˿
									 LowPin: Զ˿
									 TristatePin: Զ˿
* Return         : 0:1:
*******************************************************************************/
UINT8 ComponentIsRES_Check(UINT8 HighPin, UINT8 TristatePin, UINT8 LowPin)
{
	UINT16 adcget1;													//ɼADC
	double realvol1;												//ADCӦʵʵѹֵ
	ADC_SignalPGATypeDef mode;							//ADCģʽ
	
	Component_Discharge();
	MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
	MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);					//TristatePort->HighPort
	MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
	mode = ADC_AutoPGASelect(HighPin);
	adcget1 = ADC_GetAverage(mode, HighPin, 1);												//ɼ¶Ƿеƽ
	realvol1 = ADC_RealVol(mode, adcget1);
	if(realvol1>0.036)																								//¶˲ɼƽ
	{
		ComponentParam.CAPPARAM.front = HighPin;
		ComponentParam.CAPPARAM.rear = TristatePin;
		return 1;
	}

	Component_Discharge();
	MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);					//TristatePort->LowPort
	MeasurePort_Init(LowPort, PORT_WITH_470K, LV_NEGATIVE);
	MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);		
	mode = ADC_AutoPGASelect(LowPin);
	adcget1 = ADC_GetAverage(mode, LowPin, 1);											//ɼ¶Ƿеƽ
	realvol1 = ADC_RealVol(mode, adcget1);
	if(realvol1>0.036)																							//¶˲ɼƽ
	{
		ComponentParam.CAPPARAM.front = TristatePin;
		ComponentParam.CAPPARAM.rear = LowPin;
		return 1;
	}
	
	Component_Discharge();
	MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);			//HighPort->LowPort
	MeasurePort_Init(LowPort, PORT_WITH_680, LV_NEGATIVE);
	MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_POSITIVE);
	mode = ADC_AutoPGASelect(LowPin);
	adcget1 = ADC_GetAverage(mode, LowPin, 1);											//ɼ¶Ƿеƽ
	realvol1 = ADC_RealVol(mode, adcget1);
	if(realvol1>0.036)																							//¶˲ɼƽ
	{
		ComponentParam.CAPPARAM.front = HighPin;
		ComponentParam.CAPPARAM.rear = LowPin;
		return 1;
	}
	
	return 0;
}


/*******************************************************************************
* Function Name  : Resistance_Check
* Description    : 
* Input          : FrontPin: Զ˿
									 RearPin: Զ˿
* Return         : None
*******************************************************************************/
void Resistance_Check(UINT8 FrontPin, UINT8 RearPin)
{
	UINT16 adcget1, adcget2, adcget3, adcget4;			//ɼADC
	double realvol1, realvol2, realvol3, realvol4;	//ADCӦʵʵѹֵ
	double resval1, resval2, resval3, resval4;			//ֵ
	ADC_SignalPGATypeDef mode;											//ADCģʽ
	UINT8 RES_FLAG = 0x00;													//FLAG

	if((FrontPin==3) && (RearPin==5))
	{
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);			//һβGND---x-|-680---VCC
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(RearPin);
		adcget1 = ADC_GetAverage(mode, RearPin, 5);
		realvol1 = ADC_RealVol(mode, adcget1);
		if((realvol1<0.05)||(realvol1>3.25))
			RES_FLAG |= 0x01;																						//С
		else
		{
			resval1 = (680*realvol1)/(3.3-realvol1);
		}
		
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);				//ڶβGND---680-|-x---VCC
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget2 = ADC_GetAverage(mode, FrontPin, 5);
		realvol2 = ADC_RealVol(mode, adcget2);
		if((realvol2<0.05)||(realvol2>3.25))
			RES_FLAG |= 0x01;																						//С
		else
		{

			resval2 = (680*(3.3-realvol2))/realvol2;
		}
		
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);			//βGND---x-|-470k---VCC
		MeasurePort_Init(LowPort, PORT_WITH_470K, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(RearPin);
		adcget3 = ADC_GetAverage(mode, RearPin, 5);
		realvol3 = ADC_RealVol(mode, adcget3);
		if((realvol3<0.05)||(realvol3>3.25))
			RES_FLAG |= 0x02;																						//С
		else
		{
			resval3 = (470000*realvol3)/(3.3-realvol3);
		}
		
		MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);			//ĴβGND---470K-|-x---VCC
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(TristatePort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget4 = ADC_GetAverage(mode, FrontPin, 5);
		realvol4 = ADC_RealVol(mode, adcget4);
		if((realvol4<0.05)||(realvol4>3.25))
			RES_FLAG |= 0x02;																						//С
		else
		{
			resval4 = (470000*(3.3-realvol4))/realvol4;
		}
		
		switch(RES_FLAG)
		{
			case 0x00:		//680470kֵ
				ComponentParam.RESPARAM.ResVal = (resval1+resval2+resval3+resval4)/4;
				break;
				
			case 0x01:		//ֻ470kֵ
				ComponentParam.RESPARAM.ResVal = (resval3+resval4)/2;
				break;
				
			case 0x02:		//ֻ680ֵ
				ComponentParam.RESPARAM.ResVal = (resval1+resval2)/2;
				break;
			
			default:
				ComponentFound = COMPONENT_NONE;
				return;
		}
	}
	
	else if((FrontPin==3) && (RearPin==4))
	{
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);			//һβGND---x-|-680---VCC
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(RearPin);
		adcget1 = ADC_GetAverage(mode, RearPin, 5);
		realvol1 = ADC_RealVol(mode, adcget1);
		if((realvol1<0.05)||(realvol1>3.25))
			RES_FLAG |= 0x01;																						//С
		else
		{
			resval1 = (680*realvol1)/(3.3-realvol1);;
		}
		
		MeasurePort_Init(HighPort, PORT_WITH_680, LV_NEGATIVE);				//ڶβGND---680-|-x---VCC
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget2 = ADC_GetAverage(mode, FrontPin, 5);
		realvol2 = ADC_RealVol(mode, adcget2);
		if((realvol2<0.05)||(realvol2>3.25))
			RES_FLAG |= 0x01;																						//С
		else
		{
			resval2 = (680*(3.3-realvol2))/realvol2;
		}
		
		MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);			//βGND---x-|-470k---VCC
		MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_POSITIVE);
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(RearPin);
		adcget3 = ADC_GetAverage(mode, RearPin, 5);
		realvol3 = ADC_RealVol(mode, adcget3);
		if((realvol3<0.05)||(realvol3>3.25))
			RES_FLAG |= 0x02;																						//С
		else
		{
			resval3 = (470000*realvol3)/(3.3-realvol3);
		}
		
		MeasurePort_Init(HighPort, PORT_WITH_470K, LV_NEGATIVE);			//ĴβGND---470K-|-x---VCC
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(LowPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget4 = ADC_GetAverage(mode, FrontPin, 5);
		realvol4 = ADC_RealVol(mode, adcget4);
		if((realvol4<0.05)||(realvol4>3.25))
			RES_FLAG |= 0x02;																						//С
		else
		{
			resval4 = (470000*(3.3-realvol4))/realvol4;
		}
		
		switch(RES_FLAG)
		{
			case 0x00:		//680470kֵ
				ComponentParam.RESPARAM.ResVal = (resval1+resval2+resval3+resval4)/4;
				break;
				
			case 0x01:		//ֻ470kֵ
				ComponentParam.RESPARAM.ResVal = (resval3+resval4)/2;
				break;
				
			case 0x02:		//ֻ680ֵ
				ComponentParam.RESPARAM.ResVal = (resval1+resval2)/2;
				break;
			
			default:
				ComponentFound = COMPONENT_NONE;
				return;
		}
	}
	
	else if((FrontPin==4) && (RearPin==5))
	{
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);		//һβGND---x-|-680---VCC
		MeasurePort_Init(LowPort, PORT_WITH_680, LV_POSITIVE);
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(RearPin);
		adcget1 = ADC_GetAverage(mode, RearPin, 5);
		realvol1 = ADC_RealVol(mode, adcget1);
		if((realvol1<0.05)||(realvol1>3.25))
			RES_FLAG |= 0x01;																							//С
		else
		{
			resval1 = (680*realvol1)/(3.3-realvol1);
		}
		
		MeasurePort_Init(TristatePort, PORT_WITH_680, LV_NEGATIVE);			//ڶβGND---680-|-x---VCC
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget2 = ADC_GetAverage(mode, FrontPin, 5);
		realvol2 = ADC_RealVol(mode, adcget2);
		if((realvol2<0.05)||(realvol2>3.25))
			RES_FLAG |= 0x01;																							//С
		else
		{
			resval2 = (680*(3.3-realvol2))/realvol2;
		}
		
		MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);		//βGND---x-|-470k---VCC
		MeasurePort_Init(LowPort, PORT_WITH_470K, LV_POSITIVE);
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(RearPin);
		adcget3 = ADC_GetAverage(mode, RearPin, 5);
		realvol3 = ADC_RealVol(mode, adcget3);
		if((realvol3<0.05)||(realvol3>3.25))
			RES_FLAG |= 0x02;																							//С
		else
		{

			resval3 = (470000*realvol3)/(3.3-realvol3);
		}
		
		MeasurePort_Init(TristatePort, PORT_WITH_470K, LV_NEGATIVE);		//ĴβGND---470K-|-x---VCC
		MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_POSITIVE);
		MeasurePort_Init(HighPort, PORT_FLOATING, LV_NEGATIVE);
		mode = ADC_AutoPGASelect(FrontPin);
		adcget4 = ADC_GetAverage(mode, FrontPin, 5);
		realvol4 = ADC_RealVol(mode, adcget4);
		if((realvol4<0.05)||(realvol4>3.25))
			RES_FLAG |= 0x02;																							//С
		else
		{
			resval4 = (470000*(3.3-realvol4))/realvol4;
		}
		
		switch(RES_FLAG)
		{
			case 0x00:		//680470kֵ
				ComponentParam.RESPARAM.ResVal = (resval1+resval2+resval3+resval4)/4;
				break;
				
			case 0x01:		//ֻ470kֵ
				ComponentParam.RESPARAM.ResVal = (resval3+resval4)/2;
				break;
				
			case 0x02:		//ֻ680ֵ
				ComponentParam.RESPARAM.ResVal = (resval1+resval2)/2;
				break;
			
			default:
				ComponentFound = COMPONENT_NONE;
				return;
		}
	}
}


/*******************************************************************************
* Function Name  : Component_Discharge
* Description    : Ԫŵ
* Input          : None		
* Return         : None
*******************************************************************************/
void Component_Discharge(void)
{
	MeasurePort_Init(HighPort, PORT_WITH_NONE, LV_NEGATIVE);
	MeasurePort_Init(TristatePort, PORT_WITH_NONE, LV_NEGATIVE);
	MeasurePort_Init(LowPort, PORT_WITH_NONE, LV_NEGATIVE);
	DelayMs(50);
}


/*******************************************************************************
* Function Name  : MeasurePort_Init
* Description    : ʼԶ˿ģʽ
* Input          : port: ˿ѡ
									 mode: ˿ģʽѡ
									 level: ƽã˿ģʽΪʱü
* Return         : None
*******************************************************************************/
void MeasurePort_Init(MEASUREPORT port, PORTMODE mode, UINT8 level)
{
	switch(mode)
	{
		case PORT_WITH_NONE:
			if(level)
				GPIO_SetBits(port.PIN_WITH_NONE);
			else
				GPIO_ResetBits(port.PIN_WITH_NONE);
			GPIO_ModeCfg(port.PIN_WITH_NONE, GPIO_ModeOut_PP_20mA);
			GPIO_ModeCfg(port.PIN_WITH_680, GPIO_ModeIN_Floating);
			GPIO_ModeCfg(port.PIN_WITH_470K, GPIO_ModeIN_Floating);
			break;
		
		case PORT_WITH_680:
			GPIO_ModeCfg(port.PIN_WITH_NONE, GPIO_ModeIN_Floating);
			if(level)
				GPIO_SetBits(port.PIN_WITH_680);
			else
				GPIO_ResetBits(port.PIN_WITH_680);
			GPIO_ModeCfg(port.PIN_WITH_680, GPIO_ModeOut_PP_20mA);
			GPIO_ModeCfg(port.PIN_WITH_470K, GPIO_ModeIN_Floating);
			break;
			
		case PORT_WITH_470K:
			GPIO_ModeCfg(port.PIN_WITH_NONE, GPIO_ModeIN_Floating);
			GPIO_ModeCfg(port.PIN_WITH_680, GPIO_ModeIN_Floating);
			if(level)
				GPIO_SetBits(port.PIN_WITH_470K);
			else
				GPIO_ResetBits(port.PIN_WITH_470K);		
			GPIO_ModeCfg(port.PIN_WITH_470K, GPIO_ModeOut_PP_20mA);
			break;
			
		case PORT_FLOATING:
			GPIO_ModeCfg(port.PIN_WITH_NONE, GPIO_ModeIN_Floating);
			GPIO_ModeCfg(port.PIN_WITH_680, GPIO_ModeIN_Floating);
			GPIO_ModeCfg(port.PIN_WITH_470K, GPIO_ModeIN_Floating);
			break;
		
		default:
			break;
	}
}


/*******************************************************************************
* Function Name  : Component_Discharge
* Description    : Ԫŵ
* Input          : None		
* Return         : None
*******************************************************************************/
UINT8 StringCompare(UINT8* pArr1, UINT8* pArr2, UINT8 len)
{
	int i, j, temp;
	UINT8 arr[3];
	
	for(i=0; i<len; ++i)
	{
		arr[i] = pArr1[i];
	}
	
	for(i=len-1; i>0; --i)
	{
		for(j=0; j<i; ++j)
		{
			if(arr[j]>arr[j+1])
			{
				temp = arr[j];
				arr[j] = arr[j+1];
				arr[j+1] = temp;
			}
			if(pArr2[j]>pArr2[j+1])
			{
				temp = pArr2[j];
				pArr2[j] = pArr2[j+1];
				pArr2[j+1] = temp;
			}
		}
	}
	
//	PRINT("%d%d%d\n",pArr1[0], pArr1[1], pArr1[2]);
//	PRINT("%d%d%d\n",pArr2[0], pArr2[1], pArr2[2]);
	
	for(i = 0; i<len; ++i)
	{
		if(arr[i] != pArr2[i])
			break;
	}
	
	if(i == len)		
		return 1;
	else
		return 0;
}
