#include "gpio.h"

/*******************************************************************************
* Function Name  : GPIO_ModeCfg
* Description    : GPIOģʽ
* Input          : pin: ˿ѡ
									 mode: ģʽ
* Return         : None
*******************************************************************************/
void GPIO_ModeCfg(UINT32 pin, GPIOModeTypeDef mode)
{
	if(pin & 0x80000000)
	{
		pin &= 0x7FFFFFFF;
		GPIOB_ModeCfg(pin, mode);
	}
	else
	{
		GPIOA_ModeCfg(pin, mode);
	}
}


/*******************************************************************************
* Function Name  : GPIO_SetBits
* Description    : GPIOŵƽøߵƽ
* Input          : pin: ˿ѡ
* Return         : None
*******************************************************************************/
void GPIO_SetBits(UINT32 pin)
{
	if(pin & 0x80000000)
	{
		pin &= 0x7FFFFFFF;
		GPIOB_SetBits(pin);
	}
	else
	{
		GPIOA_SetBits(pin);
	}
}


/*******************************************************************************
* Function Name  : GPIO_ResetBits
* Description    : GPIOŵƽõ͵ƽ
* Input          : pin: ˿ѡ
* Return         : None
*******************************************************************************/
void GPIO_ResetBits(UINT32 pin)
{
	if(pin & 0x80000000)
	{
		pin &= 0x7FFFFFFF;
		GPIOB_ResetBits(pin);
	}
	else
	{
		GPIOA_ResetBits(pin);
	}
}
