#ifndef __i2c_h
#define __i2c_h
#include "CH57x_common.h"

#define SDA_OUT()		(GPIOB_ModeCfg(GPIO_Pin_4, GPIO_ModeOut_PP_5mA))	//Ϊ
#define SDA_IN()		(GPIOB_ModeCfg(GPIO_Pin_4, GPIO_ModeIN_PU))				//Ϊ
#define READ_SDA()	(GPIOB_ReadPortPin(GPIO_Pin_4))										//ȡߵ

#define I2C_SCL_HIGH()		(GPIOB_SetBits(GPIO_Pin_7))									//ʱΪߵƽ
#define I2C_SCL_LOW()			(GPIOB_ResetBits(GPIO_Pin_7))								//ʱΪ͵ƽ
#define I2C_SDA_HIGH()		(GPIOB_SetBits(GPIO_Pin_4))									//Ϊߵƽ
#define I2C_SDA_LOW()			(GPIOB_ResetBits(GPIO_Pin_4))								//Ϊ͵ƽ

void I2C_Init(void);
void I2C_Start(void);
void I2C_Stop(void);
UINT8 I2C_WaitAck(void);
void I2C_Ack(void);
void I2C_NAck(void);
void I2C_SendByte(UINT8 txd);
UINT8 I2C_ReceiveByte(UINT8 ack);

#endif
