#ifndef __OLED_H
#define __OLED_H
#include "CH57x_common.h"
#include "i2c.h"

void OLED_WriteCmd(UINT8 cmd);
void OLED_WriteData(UINT8 data);
void OLED_RefreshGram(void);
void OLED_Clear(void);
void OLED_DisplayOn(void);
void OLED_DisplayOff(void);
void OLED_DrawPoint(UINT8 x, UINT8 y, UINT8 s);
void OLED_Fill(UINT8 x1, UINT8 x2, UINT8 y1, UINT8 y2, UINT8 s);
void OLED_ShowChar(UINT8 x, UINT8 y, UINT8 ch, UINT8 size);
UINT32 MyPow(UINT8 m, UINT8 n);
void OLED_ShowNum(UINT8 x, UINT8 y, UINT32 num, UINT8 len, UINT8 size);
void OLED_ShowString(UINT8 x, UINT8 y, UINT8 *p, UINT8 size);
void OLED_Init(void);
void OLED_ShowResPic(UINT8 x, UINT8 y);
void OLED_ShowOhmUnit(UINT8 x, UINT8 y);
void OLED_ShowCapPic(UINT8 x, UINT8 y);
void OLED_ShowIndPic(UINT8 x, UINT8 y);
void OLED_ShowDioPic(UINT8 x, UINT8 y);
void OLED_ShowPBJTPic(UINT8 x, UINT8 y);
void OLED_ShowNBJTPic(UINT8 x, UINT8 y);
void OLED_ShowPJEFPic(UINT8 x, UINT8 y);
void OLED_ShowNJEFPic(UINT8 x, UINT8 y);
void OLED_ShowPEMOSPic(UINT8 x, UINT8 y);
void OLED_ShowNEMOSPic(UINT8 x, UINT8 y);
void OLED_ShowPDMOSPic(UINT8 x, UINT8 y);
void OLED_ShowNDMOSPic(UINT8 x, UINT8 y);
void OLED_ShowNEMOSDIOPic(UINT8 x, UINT8 y);
void OLED_ShowPEMOSDIOPic(UINT8 x, UINT8 y);

#endif
